<?

//-----------------------------------------------------------------------------
// GRAPHIC FORMAT
//-----------------------------------------------------------------------------
// This will be the graphic format used for all I/O in FEIDIAN. BMP is Windows
// Bitmap format -- which has been almost universally supported on other
// operating systems. However, if you want, you can use XPM format instead,
// which may be ideal for anyone using X-Windows.

define("GRAPHIC_FORMAT", "bmp");
//define("GRAPHIC_FORMAT", "xpm");

//-----------------------------------------------------------------------------
// FONT OUTPUT SETTINGS
//-----------------------------------------------------------------------------
// Default font name
$fontname = "My Font Name";

// Default font copyright (no more than 255 characters);
$copyright = "This font file was generated by FEIDIAN.";

//-----------------------------------------------------------------------------
// BINARY CHARACTER RECOGNITION SETTINGS
//-----------------------------------------------------------------------------
// Not found character - Specify the character to substitute when a tile isn't
// matched.
$not_found = "  ";

// Specify how many bytes characters in the text representation are. \n \r \t
// are ignored in the map. For most Asian languages, this should be "2"
$char_bytes = "2";

// Hash method - You should select one because arrays are prone to error if
// they have to handle thousands of strings longer than 80 bytes. Information
// about each hash method is below:

// RFC 1321 - The MD5 Message-Digest Algorithm:
//   MD5 is a fast one-way hash with a 1:32^16 chance of error.
//   It is usuallyclocked at 50% more efficent than SHA1
//
define("HASH_METHOD", "md5");

// CRC32 - 32-bit cyclic redudnacy checksum
//   Very fast, but more likely to be incorrect than MD5sum or SHA1
//
//define("HASH_METHOD", "crc32");

// US Secure Hash Algorithm 1:
//   SHA1 is an extremely secure one-way hash with virtually no chance of
//   error. It is, however, fairly slow. Not recommended for under 1.5GHz.
//
//define("HASH_METHOD", "sha1");

// None:
//   No hashing. BCR will use the full, actual binary data instead. This is
//   safe for small tiles, but in larger tiles, there can be data failure and
//   hundreds of incorrect matches.
//
//define("HASH_METHOD", "none");

// Do you want to GZIP the tiles to make them smaller? This will increase the
// speed of the actual tile matching, but the gzipping itself may cause some
// lag.
//
//define("GZIP_TILES", TRUE);

//-----------------------------------------------------------------------------
// CUSTOM TILES
//-----------------------------------------------------------------------------
// Because most people are not able to type European characters, this option
// is not enabled by default. If you enable this option, you will be able to
// use 0xa0-0xef in your character definitions. On Asian Systems, these bytes
// are reserved for special dual-byte characters. Keep in mind when using this
// range, not everyone will be compatable with it
//
// A map of the European characters which will be added follows.
//   
//   
//   
//   
//   
//
//define("EXTEND_LETTERS", TRUE);

?>